package handler

import (
	"GtDataStore/app/cmd/events/internal/logic/job"
	"GtDataStore/app/cmd/events/internal/svc"
	"GtDataStore/app/model"
	"context"
	"github.com/zeromicro/go-zero/core/logx"
)

func EventMulti(ctx context.Context, task *job.Task, technologyName string) error {
	// 1. 查询所有的设备
	_, err := findMultiRecord(task.Job.SvcCtx, int64(task.Id))
	if err != nil {
		return err
	}

	return nil
}

func findMultiRecord(svcCtx *svc.ServiceContext, projectId int64) ([]model.DcEventBind, error) {
	if records, err := svcCtx.DcEventBind.FindByProjectIdRuleFlag(context.Background(), projectId, EVENT_MULTI_ITEM); err != nil {
		logx.Infof("findMultiRecord not found record")
		return nil, err
	} else {
		return records, nil
	}
}
